#include "ruby_util.h"

void rb_p(VALUE v)
{
  rb_funcall(rb_cObject, rb_intern("p"), 1, v);
}

VALUE rb_call_method(VALUE recv, const char *method, int argc, ...)
{
  VALUE ret;
  
  va_list varg;
  va_start(varg, argc);
  ret = rb_call_method_by_varg(recv, method, argc, varg);
  va_end(varg);
  
  return ret;
}

VALUE rb_call_method_by_varg(VALUE recv, const char *method, int argc, va_list varg)
{
  VALUE argv[argc];
  
  for( int i = 0; i < argc; i++ ){
    argv[i] = va_arg(varg, VALUE);
  }
  
  return rb_call_method_by_ary(recv, method, argc, argv);
}
