#ifndef TOKEN_H__
#define TOKEN_H__

#define Lexer_TOKEN_LIST() \
  Lexer_C_TOKEN_LIST() \
  Lexer_LUA_TOKEN_LIST()

#define Lexer_C_TOKEN_LIST() \
  Lexer_C_TOKEN_PROC(AUTO, KEYWORD, "auto") \
  Lexer_C_TOKEN_PROC(BREAK, KEYWORD, "break") \
  Lexer_C_TOKEN_PROC(CASE, KEYWORD, "case") \
  Lexer_C_TOKEN_PROC(CHAR, KEYWORD, "char") \
  Lexer_C_TOKEN_PROC(CONST, KEYWORD, "const") \
  Lexer_C_TOKEN_PROC(CONTINUE, KEYWORD, "continue") \
  Lexer_C_TOKEN_PROC(DEFAULT, KEYWORD, "default") \
  Lexer_C_TOKEN_PROC(DO, KEYWORD, "do") \
  Lexer_C_TOKEN_PROC(DOUBLE, KEYWORD, "double") \
  Lexer_C_TOKEN_PROC(ELSE, KEYWORD, "else") \
  Lexer_C_TOKEN_PROC(ENUM, KEYWORD, "enum") \
  Lexer_C_TOKEN_PROC(EXTERN, KEYWORD, "extern") \
  Lexer_C_TOKEN_PROC(FLOAT, KEYWORD, "float") \
  Lexer_C_TOKEN_PROC(FOR, KEYWORD, "for") \
  Lexer_C_TOKEN_PROC(GOTO, KEYWORD, "goto") \
  Lexer_C_TOKEN_PROC(IF, KEYWORD, "if") \
  Lexer_C_TOKEN_PROC(INLINE, KEYWORD, "inline") \
  Lexer_C_TOKEN_PROC(INT, KEYWORD, "int") \
  Lexer_C_TOKEN_PROC(LONG, KEYWORD, "long") \
  Lexer_C_TOKEN_PROC(REGISTER, KEYWORD, "register") \
  Lexer_C_TOKEN_PROC(RESTRICT, KEYWORD, "restrict") \
  Lexer_C_TOKEN_PROC(RETURN, KEYWORD, "return") \
  Lexer_C_TOKEN_PROC(SHORT, KEYWORD, "short") \
  Lexer_C_TOKEN_PROC(SIGNED, KEYWORD, "signed") \
  Lexer_C_TOKEN_PROC(SIZEOF, KEYWORD, "sizeof") \
  Lexer_C_TOKEN_PROC(STATIC, KEYWORD, "static") \
  Lexer_C_TOKEN_PROC(STRUCT, KEYWORD, "struct") \
  Lexer_C_TOKEN_PROC(SWITCH, KEYWORD, "switch") \
  Lexer_C_TOKEN_PROC(TYPEDEF, KEYWORD, "typedef") \
  Lexer_C_TOKEN_PROC(UNION, KEYWORD, "union") \
  Lexer_C_TOKEN_PROC(UNSIGNED, KEYWORD, "unsigned") \
  Lexer_C_TOKEN_PROC(VOID, KEYWORD, "void") \
  Lexer_C_TOKEN_PROC(VOLATILE, KEYWORD, "volatile") \
  Lexer_C_TOKEN_PROC(WHILE, KEYWORD, "while") \
  Lexer_C_TOKEN_PROC(BOOL, KEYWORD, "_Bool") \
  Lexer_C_TOKEN_PROC(COMPLEX, KEYWORD, "_Complex") \
  Lexer_C_TOKEN_PROC(IMAGINARY, KEYWORD, "_Imaginary") \
  Lexer_C_TOKEN_PROC(ASM, KEYWORD, "__asm__") \
  Lexer_C_TOKEN_PROC(ATTRIBUTE, KEYWORD, "__attribute__") \
  Lexer_C_TOKEN_PROC(EXTENSION, KEYWORD, "__extension__") \
  Lexer_C_TOKEN_PROC(US_RESCRICT, KEYWORD, "__restrict") \
  Lexer_C_TOKEN_PROC(L_BRACKET, KEYWORD, "[") \
  Lexer_C_TOKEN_PROC(R_BRACKET, KEYWORD, "]") \
  Lexer_C_TOKEN_PROC(L_PAR, KEYWORD, "(") \
  Lexer_C_TOKEN_PROC(R_PAR, KEYWORD, ")") \
  Lexer_C_TOKEN_PROC(L_BRACE, KEYWORD, "{") \
  Lexer_C_TOKEN_PROC(R_BRACE, KEYWORD, "}") \
  Lexer_C_TOKEN_PROC(DOT, KEYWORD, ".") \
  Lexer_C_TOKEN_PROC(ARROW, KEYWORD, "->") \
  Lexer_C_TOKEN_PROC(INC, KEYWORD, "++") \
  Lexer_C_TOKEN_PROC(DEC, KEYWORD, "--") \
  Lexer_C_TOKEN_PROC(AND, KEYWORD, "&") \
  Lexer_C_TOKEN_PROC(MUL, KEYWORD, "*") \
  Lexer_C_TOKEN_PROC(PLUS, KEYWORD, "+") \
  Lexer_C_TOKEN_PROC(MINUS, KEYWORD, "-") \
  Lexer_C_TOKEN_PROC(TILDE, KEYWORD, "~") \
  Lexer_C_TOKEN_PROC(NOT, KEYWORD, "!") \
  Lexer_C_TOKEN_PROC(DIV, KEYWORD, "/") \
  Lexer_C_TOKEN_PROC(MOD, KEYWORD, "%") \
  Lexer_C_TOKEN_PROC(LSHIFT, KEYWORD, "<<") \
  Lexer_C_TOKEN_PROC(RSHIFT, KEYWORD, ">>") \
  Lexer_C_TOKEN_PROC(LTHAN, KEYWORD, "<") \
  Lexer_C_TOKEN_PROC(GTHAN, KEYWORD, ">") \
  Lexer_C_TOKEN_PROC(LEQ, KEYWORD, "<=") \
  Lexer_C_TOKEN_PROC(REQ, KEYWORD, ">=") \
  Lexer_C_TOKEN_PROC(EQL, KEYWORD, "==") \
  Lexer_C_TOKEN_PROC(NEQ, KEYWORD, "!=") \
  Lexer_C_TOKEN_PROC(XOR, KEYWORD, "^") \
  Lexer_C_TOKEN_PROC(LOR, KEYWORD, "||") \
  Lexer_C_TOKEN_PROC(LAND, KEYWORD, "&&") \
  Lexer_C_TOKEN_PROC(BOR, KEYWORD, "|") \
  Lexer_C_TOKEN_PROC(COND, KEYWORD, "?") \
  Lexer_C_TOKEN_PROC(SELECT, KEYWORD, ":") \
  Lexer_C_TOKEN_PROC(SEMICOLON, KEYWORD, ";") \
  Lexer_C_TOKEN_PROC(VARG, KEYWORD, "...") \
  Lexer_C_TOKEN_PROC(ASSIGN, KEYWORD, "=") \
  Lexer_C_TOKEN_PROC(MUL_ASSIGN, KEYWORD, "*=") \
  Lexer_C_TOKEN_PROC(DIV_ASSIGN, KEYWORD, "/=") \
  Lexer_C_TOKEN_PROC(MOD_ASSIGN, KEYWORD, "%=") \
  Lexer_C_TOKEN_PROC(ADD_ASSIGN, KEYWORD, "+=") \
  Lexer_C_TOKEN_PROC(SUB_ASSIGN, KEYWORD, "-=") \
  Lexer_C_TOKEN_PROC(LSHIFT_ASSIGN, KEYWORD, "<<=") \
  Lexer_C_TOKEN_PROC(RSHIFT_ASSIGN, KEYWORD, ">>=") \
  Lexer_C_TOKEN_PROC(BAND_ASSIGN, KEYWORD, "&=") \
  Lexer_C_TOKEN_PROC(XOR_ASSIGN, KEYWORD, "^=") \
  Lexer_C_TOKEN_PROC(BOR_ASSIGN, KEYWORD, "|=") \
  Lexer_C_TOKEN_PROC(COMMA, KEYWORD, ",") \
  Lexer_C_TOKEN_PROC(LUA, KEYWORD, "_lua") \
  Lexer_C_TOKEN_PROC(INT_LITERAL, LITERAL, "C_INT_LITERAL") \
  Lexer_C_TOKEN_PROC(FLOAT_LITERAL, LITERAL, "C_FLOAT_LITERAL") \
  Lexer_C_TOKEN_PROC(CHAR_LITERAL, LITERAL, "C_CHAR_LITERAL") \
  Lexer_C_TOKEN_PROC(STRING_LITERAL, LITERAL, "C_STRING_LITERAL") \
  Lexer_C_TOKEN_PROC(NAME, LITERAL, "C_NAME") \
  Lexer_C_TOKEN_PROC(TYPEDEF_NAME, LITERAL, "C_TYPEDEF_NAME")

#define Lexer_LUA_TOKEN_LIST() \
  Lexer_LUA_TOKEN_PROC(AND, KEYWORD, "and") \
  Lexer_LUA_TOKEN_PROC(BREAK, KEYWORD, "break") \
  Lexer_LUA_TOKEN_PROC(DO, KEYWORD, "do") \
  Lexer_LUA_TOKEN_PROC(ELSE, KEYWORD, "else") \
  Lexer_LUA_TOKEN_PROC(ELSEIF, KEYWORD, "elseif") \
  Lexer_LUA_TOKEN_PROC(END, KEYWORD, "end") \
  Lexer_LUA_TOKEN_PROC(FALSE, KEYWORD, "false") \
  Lexer_LUA_TOKEN_PROC(FOR, KEYWORD, "for") \
  Lexer_LUA_TOKEN_PROC(FUNCTION, KEYWORD, "function") \
  Lexer_LUA_TOKEN_PROC(GOTO, KEYWORD, "goto") \
  Lexer_LUA_TOKEN_PROC(IF, KEYWORD, "if") \
  Lexer_LUA_TOKEN_PROC(IN, KEYWORD, "in") \
  Lexer_LUA_TOKEN_PROC(LOCAL, KEYWORD, "local") \
  Lexer_LUA_TOKEN_PROC(NIL, KEYWORD, "nil") \
  Lexer_LUA_TOKEN_PROC(NOT, KEYWORD, "not") \
  Lexer_LUA_TOKEN_PROC(OR, KEYWORD, "or") \
  Lexer_LUA_TOKEN_PROC(REPEAT, KEYWORD, "repeat") \
  Lexer_LUA_TOKEN_PROC(RETURN, KEYWORD, "return") \
  Lexer_LUA_TOKEN_PROC(THEN, KEYWORD, "then") \
  Lexer_LUA_TOKEN_PROC(TRUE, KEYWORD, "true") \
  Lexer_LUA_TOKEN_PROC(UNTIL, KEYWORD, "until") \
  Lexer_LUA_TOKEN_PROC(WHILE, KEYWORD, "while") \
  Lexer_LUA_TOKEN_PROC(ADD, KEYWORD, "+") \
  Lexer_LUA_TOKEN_PROC(SUB, KEYWORD, "-") \
  Lexer_LUA_TOKEN_PROC(MUL, KEYWORD, "*") \
  Lexer_LUA_TOKEN_PROC(DIV, KEYWORD, "/") \
  Lexer_LUA_TOKEN_PROC(MOD, KEYWORD, "%") \
  Lexer_LUA_TOKEN_PROC(POW, KEYWORD, "^") \
  Lexer_LUA_TOKEN_PROC(LEN, KEYWORD, "#") \
  Lexer_LUA_TOKEN_PROC(EQL, KEYWORD, "==") \
  Lexer_LUA_TOKEN_PROC(NEQ, KEYWORD, "~=") \
  Lexer_LUA_TOKEN_PROC(LEQ, KEYWORD, "<=") \
  Lexer_LUA_TOKEN_PROC(GEQ, KEYWORD, ">=") \
  Lexer_LUA_TOKEN_PROC(LTN, KEYWORD, "<") \
  Lexer_LUA_TOKEN_PROC(GTN, KEYWORD, ">") \
  Lexer_LUA_TOKEN_PROC(ASSIGN, KEYWORD, "=") \
  Lexer_LUA_TOKEN_PROC(L_PAR, KEYWORD, "(") \
  Lexer_LUA_TOKEN_PROC(R_PAR, KEYWORD, ")") \
  Lexer_LUA_TOKEN_PROC(L_BRACE, KEYWORD, "{") \
  Lexer_LUA_TOKEN_PROC(R_BRACE, KEYWORD, "}") \
  Lexer_LUA_TOKEN_PROC(L_BRACKET, KEYWORD, "[") \
  Lexer_LUA_TOKEN_PROC(R_BRACKET, KEYWORD, "]") \
  Lexer_LUA_TOKEN_PROC(LABEL, KEYWORD, "::") \
  Lexer_LUA_TOKEN_PROC(COLON, KEYWORD, ":") \
  Lexer_LUA_TOKEN_PROC(SEMICOLON, KEYWORD, ";") \
  Lexer_LUA_TOKEN_PROC(COMMA, KEYWORD, ",") \
  Lexer_LUA_TOKEN_PROC(DOT, KEYWORD, ".") \
  Lexer_LUA_TOKEN_PROC(APPEND, KEYWORD, "..") \
  Lexer_LUA_TOKEN_PROC(VARG, KEYWORD, "...") \
  Lexer_LUA_TOKEN_PROC(BACK_QUOTE, KEYWORD, "`") \
  Lexer_LUA_TOKEN_PROC(C_LOCAL, KEYWORD, "_clocal") \
  Lexer_LUA_TOKEN_PROC(PROTECTED, KEYWORD, "protected") \
  Lexer_LUA_TOKEN_PROC(SETMETATABLE, KEYWORD, "_setmetatable") \
  Lexer_LUA_TOKEN_PROC(INT_LITERAL, LITERAL, "Lua_INT_LITERAL") \
  Lexer_LUA_TOKEN_PROC(FLOAT_LITERAL, LITERAL, "Lua_FLOAT_LITERAL") \
  Lexer_LUA_TOKEN_PROC(STRING_LITERAL, LITERAL, "Lua_STRING_LITERAL") \
  Lexer_LUA_TOKEN_PROC(NAME, LITERAL, "Lua_NAME")

#endif
