module Luca
  class Analyzer
    class JumpAnalyzer
      include Varspec::BuiltinMatcher
      
      def analyze(program)
        expect_var[:program].to_be Ast::C::Program
        @loop_stack = []
        
        program.lua_stmt_list.each do |lua_stmt|
          analyze_ast(lua_stmt.lua_program)
        end
      end
      
      def analyze_ast(ast)
        expect_var[:ast].to_be Ast::Lua
        ast.analyze_jump_by(self)
      end
      
      def analyze_list(list)
        expect_var[:list].to_be ArrayOf(Ast::Lua)
        list.each do |ast|
          analyze_ast(ast)
        end
      end
      
      def nest_loop(stmt)
        expect_var[:stmt].to_be Or(Ast::Lua::ForStmt, Ast::Lua::ForInStmt, Ast::Lua::WhileStmt)
        @loop_stack.push(stmt)
        yield
        @loop_stack.pop
      end
      
      def current_loop
        @loop_stack.last
      end
    end
  end
end
