module Luca
  class Ast
    class C
      # Cの<tt>__asm__</tt>文を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class Asm < C
        @is_abstract = false
        
        # @return [Token]
        attr_reader :asm_tk
        
        # @return [Token]
        attr_reader :lparen_tk
        
        # @return [StringLiteral] アセンブリコードの文字列リテラル
        attr_reader :code
        
        # @return [Token]
        attr_reader :rparen_tk
        
        def initialize(asm_tk, lparen_tk, code, rparen_tk)
          expect_var[:asm_tk].of_instance_to_be Token
          expect_var[:lparen_tk].of_instance_to_be Token
          expect_var[:code].of_instance_to_be StringLiteral
          expect_var[:rparen_tk].of_instance_to_be Token
          super(asm_tk.line, rparen_tk.line)
        end
        
        def print_by(cxt)
          cxt << asm_tk << lparen_tk << code << rparen_tk
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(code, self)
        end
      end
    end
  end
end
