module Luca
  class Ast
    class C
      # Cの二項演算を表すASTノード
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class BinOpNode < OpNode
        @is_abstract = true
        
        def initialize(left, op_tk, right)
          super(left.start_pos, right.end_pos, [op_tk], [left, right])
        end
        
        def op_tk
          op_tk_list.first
        end
        
        def operator
          op_tk.value
        end
        
        # 左オペランドを返す
        #
        #
        # @return [Expr] 
        # 
        def left
          operand_list[0]
        end
        
        # 右オペランドを返す
        #
        #
        # @return [Expr] 
        # 
        def right
          operand_list[1]
        end
        
        def print_by(cxt)
          if operator == ','
            cxt << left << op_tk << ' ' << right
          else
            cxt << left << '' << op_tk << ' ' << right
          end
        end
      end
    end
  end
end
