module Luca
  class Ast
    class C
      # Cの<tt>break</tt>文を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class BreakStmt < Stmt
        @is_abstract = false
        
        # @return [Token]
        attr_reader :break_tk
        
        # @return [Token]
        attr_reader :scol_tk
        
        def initialize(break_tk, scol_tk)
          expect_var[:break_tk].of_instance_to_be Token
          expect_var[:scol_tk].of_instance_to_be Token
          super(break_tk, scol_tk)
        end
        
        def print_by(cxt)
          cxt << break_tk << scol_tk
        end
        
        def set_parent_by(cxt)
          
        end
      end
    end
  end
end
