module Luca
  class Ast
    class C
      # Cのキャスト式を表すASTノード
      # 
      # @author autopp <autopp.inc@gmail.com>
      #
      class CastExpr < Expr
        @is_abstract = false
        
        # @return [Token]
        attr_reader :lparen_tk
        
        # @return [TypeName] 
        attr_reader :type_name
        
        # @return [Token]
        attr_reader :rparen_tk
        
        # @return [Expr] 
        attr_reader :operand
        
        def initialize(lparen_tk, type_name, rparen_tk, operand)
          expect_var[:lparen_tk].of_instance_to_be Token
          expect_var[:type_name].of_instance_to_be TypeName
          expect_var[:rparen_tk].of_instance_to_be Token
          expect_var[:operand].of_instance_to_be Expr
          super(lparen_tk.line, operand.end_pos)
        end
        
        def print_by(cxt)
          cxt << lparen_tk << type_name << rparen_tk << operand
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(type_name, self)
          cxt.set_parent_of_ast(operand, self)
        end
        
        def analyze_scope_by(cxt)
          analyze_scope_of_ivar_by(cxt, :@operand)
        end
      end
    end
  end
end
