module Luca
  class Ast
    class C
      # Cの条件演算を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class ConditionalOpNode < OpNode
        @is_abstract = false
        
        def initialize(cond_expr, question_tk, then_expr, col_tk, else_expr)
          super(cond_expr.start_pos, else_expr.end_pos, [question_tk, col_tk], [cond_expr, then_expr, else_expr])
        end
        
        # 条件式を返す
        #
        #
        # @return [Expr] 
        # 
        def cond_expr
          operand_list[0]
        end
        
        # 
        #
        #
        # @return [Token]
        # 
        def question_tk
          op_tk_list.first
        end
        
        # then式を返す
        #
        #
        # @return [Expr] 
        # 
        def then_expr
          operand_list[1]
        end
        
        # 
        #
        #
        # @return [Token]
        # 
        def col_tk
          op_tk_list[1]
        end
        
        # else式を返す

        #
        #
        # @return [Expr] 
        # 
        def else_expr
          operand_list[2]
        end
        
        def print_by(cxt)
          cxt << cond_expr
          cxt << ' ' << question_tk << ' '
          cxt << then_expr
          cxt << ' ' << col_tk << ' '
          cxt << else_expr
        end
      end
    end
  end
end
