module Luca
  class Ast
    class C
      # Cの宣言子に対する<tt>__attribute__</tt>を表すASTノード
      # 
      # 構文的には<tt>Pointer</tt>と同格
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class DeclaratorAttribute < C
        @is_abstract = false
        
        # @return [Attribute] 
        attr_reader :attribute
        
        # @return [[TypeQualifier]] 
        attr_reader :qualifier_list
        
        def initialize(attribute, qualifier_list = [])
          expect_var[:attribute].of_instance_to_be Attribute
          expect_var[:qualifier_list].of_instance_to_be ArrayOf(TypeQualifier)
          
          end_pos = qualifier_list.empty? ? attribute.end_pos : qualifier_list.last.end_pos
          super(attribute.start_pos, end_pos)
        end
        
        def print_by(cxt)
          cxt << attribute
          return if qualifier_list.empty?
          cxt << ' ' << Printer.list(qualifier_list, ' ')
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_list(qualifier_list, self)
        end
      end
    end
  end
end
