module Luca
  class Ast
    class C
      # Cの宣言子名を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class DeclaratorName < DirectDeclarator
        @is_abstract = false
        
        # @return [Token] 宣言子名トークン
        attr_reader :name_tk
        
        def initialize(name_tk)
          expect_var[:name_tk].of_instance_to_be Token
          super(name_tk.line, name_tk.line)
        end
        
        def name
          name_tk.value
        end
        
        def print_by(cxt)
          cxt << name_tk
        end
        
        def set_parent_by(cxt); end
        
        def gen_env_member_by(cxt)
          expect_var[:cxt].to_be CodeGenerator
          cxt << cxt.env_member_name(cxt.member_index)
        end
      end
    end
  end
end
