module Luca
  class Ast
    class C
      # Cの<tt>default</tt>文を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class DefaultStmt < Stmt
        @is_abstract = false
        
        # @return [Token]
        attr_reader :default_tk
        
        # @return [Token]
        attr_reader :col_tk
        
        # @return [Stmt] <tt>default</tt>ラベルが付けられた文
        attr_reader :stmt
        def initialize(default_tk, col_tk, stmt)
          expect_var[:default_tk].of_instance_to_be Token
          expect_var[:col_tk].of_instance_to_be Token
          expect_var[:stmt].of_instance_to_be Stmt
          super(default_tk.line, stmt.end_pos)
        end
        
        def print_by(cxt)
          cxt.print_token(default_tk, true)
          cxt << col_tk << stmt
        end
        
        def perform_translate_lua_by(recv, method, *args, override:, &block)
          @stmt = stmt.translate_lua_by(recv, method, *args, override: override, &block)
          self
        end
        
        def perform_traverse_lua_by(recv, method, *args, override:, &block)
          stmt.traverse_lua_by(recv, method, *args, override: override, &block)
          nil
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(stmt, self)
        end
      end
    end
  end
end
