module Luca
  class Ast
    class C
      # Cの式文を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class ExprStmt < Stmt
        @is_abstract = false
        
        # @return [Expr] 式本体
        attr_reader :expr
        
        # @return [Token]
        attr_reader :scol_tk
        
        def initialize(expr, scol_tk)
          expect_var[:expr].of_instance_to_be Expr
          expect_var[:scol_tk].of_instance_to_be Token
          
          super(expr.start_pos, scol_tk.line)
        end
        
        def print_by(cxt)
          cxt << expr << scol_tk
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(expr, self)
        end
      end
    end
  end
end
