module Luca
  class Ast
    class C
      # Cの関数修飾子を表すASTノード
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class FunctionSpecifier < DeclSpecifier
        @is_abstract = true
        
        # @return [Token]
        attr_reader :kwd_tk
        
        def initialize(kwd_tk)
          fail "#{self.class} is abstract class" if self.class == FunctionSpecifier
          
          expect_var[:kwd_tk].of_instance_to_be Token
          
          super(kwd_tk.line, kwd_tk.line)
        end
        
        def print_by(cxt)
          cxt << kwd_tk
        end
        
        def set_parent_by(cxt); end
      end
    end
  end
end
