module Luca
  class Ast
    class C
      # Cの<tt>goto</tt>文を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class GotoStmt < Stmt
        @is_abstract = false
        
        # @return [Token]
        attr_reader :goto_tk
        
        # @return [Symbol] ジャンプ先のラベル
        attr_reader :label_tk
        
        # @return [Token]
        attr_reader :scol_tk
        
        def initialize(goto_tk, label_tk, scol_tk)
          expect_var[:goto_tk].of_instance_to_be Token
          expect_var[:label_tk].of_instance_to_be Token
          expect_var[:scol_tk].of_instance_to_be Token
          super(goto_tk.line, scol_tk.line)
        end
        
        def label
          label_tk.value
        end
        
        def print_by(cxt)
          cxt << goto_tk << ' ' << label_tk << scol_tk
        end
        
        def set_parent_by(cxt)
        end
      end
    end
  end
end
