module Luca
  class Ast
    class C
      # Cの初期化宣言子を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class InitDeclarator < C
        @is_abstract = false
        
        # @return [Declarator] 
        attr_reader :declarator
        
        # @return [Token, nil]
        attr_reader :eq_tk
        
        # @return [Initializer, nil] 
        attr_reader :initializer
        
        def initialize(declarator, eq_tk = nil, initializer = nil)
          expect_var[:declarator].of_instance_to_be Declarator
          expect_var[:eq_tk].of_instance_to_be Maybe(Token)
          expect_var[:initializer].of_instance_to_be Maybe(Initializer)
          end_pos = initializer ? initializer.end_pos : declarator.end_pos
          super(declarator.start_pos, end_pos)
        end
        
        def print_by(cxt)
          cxt << declarator
          return unless initializer
          cxt << ' ' << eq_tk << ' ' << initializer
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(declarator, self)
          cxt.set_parent_of_ast(initializer, self) if initializer
        end
      end
    end
  end
end
