module Luca
  class Ast
    class C
      # Cの引数に型注釈が無い(=> 全て<tt>int</tt>)関数宣言子
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class IntFunctionDeclarator < DirectDeclarator
        @is_abstract = false
        
        # @return [DirectDeclarator] 
        attr_reader :base_declarator
        
        # @return [Token]
        attr_reader :lparen_tk
        
        # @return [[Token]] 
        attr_reader :param_com_list
        
        # @return [Token]
        attr_reader :rparen_tk
        
        def initialize(base_declarator, lparen_tk, param_com_list, rparen_tk)
          expect_var[:base_declarator].of_instance_to_be DirectDeclarator
          expect_var[:lparen_tk].of_instance_to_be Token
          expect_var[:param_com_list].of_instance_to_be ArrayOf(Token)
          expect_var[:rparen_tk].of_instance_to_be Token
          super(base_declarator.start_pos, rparen_tk.line)
        end
        
        def name
          base_declarator ? base_declarator.name : nil
        end
        
        def print_by(cxt)
          cxt << base_declarator
          cxt << lparen_tk
          cxt.print_ast_list(param_list, ', ')
          param_com_list.each_with_index do |x, i|
            cxt << x
            cxt << ' ' if i.odd?
          end
          cxt << rparen_tk
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(base_declarator, self)
        end
      end
    end
  end
end
