module Luca
  class Ast
    class C
      # Cの定数リテラルを表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class Literal < Expr
        @is_abstract = false
        
        # @return [Token]
        attr_reader :value_tk
        
        def initialize(value_tk)
          expect_var[:value_tk].of_instance_to_be Token
          super(value_tk.line, value_tk.line)
        end
        
        def value
          value_tk.value
        end
        
        def print_by(cxt)
          cxt << value_tk
        end
        
        def set_parent_by(cxt)
        end
        
        def analyze_scope_by(cxt)
          self
        end
      end
    end
  end
end
