module Luca
  class Ast
    class C
      # Luaのスコープで宣言されているC変数を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class LuaVar < Var
        # @return [[Integer, Integer, Integer]] <tt>clocal</tt>宣言されている位置を返す
        attr_reader :access_path
        
        def initialize(name_tk, access_path)
          expect_var[:access_path].of_instance_to_be TupleOf(Integer, Integer, Integer)
          super(name_tk)
        end
        
        def gen_code_by(cxt)
          name_tk.newline_count.times do
            cxt.newline
          end
          cxt << "#{cxt.c_env_pointer(access_path[2])}->#{cxt.env_member_name(access_path[1])}"
        end
      end
    end
  end
end
