module Luca
  class Ast
    class C
      # Cの複合初期化子中のメンバ指定子を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class MemberDesignator < Designator
        @is_abstract = false
        
        # @return [Token]
        attr_reader :dot_tk
        
        # @return [Token]
        attr_reader :name_tk
        
        def initialize(dot_tk, name_tk)
          expect_var[:dot_tk].of_instance_to_be Token
          expect_var[:name_tk].of_instance_to_be Token
          super(dot_tk.line, name_tk.line)
        end
        
        def name
          name_tk.value
        end
        
        def print_ast(cxt)
          cxt << dot_tk << name_tk
        end
        
        def set_parent_by(cxt)
        end
      end
    end
  end
end
