module Luca
  class Ast
    class C
      # 演算子ノードを表すクラス
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class OpNode < Expr
        @is_abstract = true
        
        # @return [[Token]]
        attr_reader :op_tk_list
        
        # @!attribute [r] operand
        #   @return [[Expr]] オペランドの配列
        attr_reader :operand_list
        
        def initialize(start_pos, end_pos, op_tk_list, operand_list)
          fail "#{self.class} is abstract class" if self.class == OpNode
          expect_var[:op_tk_list].of_instance_to_be ArrayOf(Token)
          expect_var[:operand_list].of_instance_to_be ArrayOf(Expr)
          @operand_list.freeze
          super(start_pos, end_pos)
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_list(operand_list, self)
        end
        
        def analyze_scope_by(cxt)
          analyze_scope_of_ivar_by(cxt, :@operand_list)
        end
      end
    end
  end
end
