module Luca
  class Ast
    class C
      # Cの仮引数宣言を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class ParamDecl < C
        @is_abstract = false
        
        # @return [[DeclSpecifier]] 
        attr_reader :decl_specifier_list
        
        # @return [Declarator, nil] 
        attr_reader :declarator
        
        def initialize(decl_specifier_list, declarator = nil)
          @decl_specifier_list = expect_var[:decl_specifier_list].to_be ArrayOf(DeclSpecifier) > 0
          @declarator = expect_var[:declarator].to Maybe(Declarator)
          end_pos = declarator ? declarator.end_pos : decl_specifier_list[0].start_pos
          super(decl_specifier_list[-1].start_pos, end_pos)
        end
        
        def print_by(cxt)
          cxt.print_ast_list(decl_specifier_list, ' ')
          return unless declarator
          cxt << ' '
          cxt.print_ast(declarator)
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_list(decl_specifier_list, self)
          cxt.set_parent_of_ast(declarator, self) if declarator
        end
      end
    end
  end
end
