module Luca
  class Ast
    class C
      # Cの括弧付き宣言子を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class ParenthesesDeclarator < DirectDeclarator
        @is_abstract = false
        
        # @return [Token]
        attr_reader :lparen_tk
        
        # @return [Declarator] 
        attr_reader :inner_declarator
        
        # @return [Token]
        attr_reader :rparen_tk
        
        def initialize(lparen_tk, inner_declarator, rparen_tk)
          expect_var[:lparen_tk].of_instance_to_be Token
          expect_var[:inner_declarator].of_instance_to_be Declarator
          expect_var[:rparen_tk].of_instance_to_be Token
          super(lparen_tk.line, rparen_tk.line)
        end
        
        def name
          inner_declarator.name
        end
        
        def print_by(cxt)
          cxt << lparen_tk << inner_declarator << rparen_tk
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(inner_declarator, self)
        end
      end
    end
  end
end
