module Luca
  class Ast
    class C
      # Cの括弧付き式を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class ParenthesesExpr < Expr
        @is_abstract = false
        
        # @return [Token]
        attr_reader :lparen_tk
        
        # @return [Expr]
        attr_reader :inner_expr
        
        alias_method :expr, :inner_expr
        
        # @return [Token]
        attr_reader :rparen_tk
        
        def initialize(lparen_tk, inner_expr, rparen_tk)
          expect_var[:lparen_tk].of_instance_to_be Token
          expect_var[:inner_expr].of_instance_to_be Expr
          expect_var[:rparen_tk].of_instance_to_be Token
          super(lparen_tk.line, rparen_tk.line)
        end
        
        def print_by(cxt)
          cxt << lparen_tk << inner_expr << rparen_tk
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(inner_expr, self)
        end
        
        def gen_code_by(cxt)
          cxt << lparen_tk << inner_expr << rparen_tk
        end
        
        def analyze_scope_by(cxt)
          analyze_scope_of_ivar_by(cxt, :@inner_expr)
        end
      end
    end
  end
end
