module Luca
  class Ast
    class C
      # Cのポインタ型注釈を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class Pointer < C
        @is_abstract = false
        
        # @return [Token]
        attr_reader :ast_tk
        
        # @return [[TypeQualifier]]
        attr_reader :qualifier_list
        
        def initialize(ast_tk, qualifier_list)
          expect_var[:ast_tk].of_instance_to_be Token
          expect_var[:qualifier_list].of_instance_to_be ArrayOf(TypeQualifier)
          
          end_pos = qualifier_list.empty? ? ast_tk.line : qualifier_list[-1].end_pos
          super(ast_tk.line, end_pos)
        end
        
        def print_by(cxt)
          cxt << ast_tk
          
          return if qualifier_list.empty?
          cxt << ' '
          cxt.print_ast_list(qualifier_list, ' ')
          cxt << ' '
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_list(qualifier_list, self)
        end
      end
    end
  end
end
