module Luca
  class Ast
    class C
      # Cの<tt>return</tt>文を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class ReturnStmt < Stmt
        @is_abstract = false
        
        # @return [Token]
        attr_reader :return_tk
        
        # @return [Expr, nil] 戻り値の式
        attr_reader :expr
        
        # @return [Token]
        attr_reader :scol_tk
        
        def initialize(return_tk, expr, scol_tk)
          expect_var[:return_tk].of_instance_to_be Token
          @expr = expect_var[:expr].to Maybe(Expr)
          expect_var[:scol_tk].of_instance_to_be Token
          super(return_tk.line, scol_tk.line)
        end
        
        def print_by(cxt)
          cxt << return_tk << ' '
          cxt << expr if expr
          cxt << scol_tk
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(expr, self) if expr
        end
      end
    end
  end
end
