module Luca
  class Ast
    class C
      # Cの単純初期化子を表すASTノード
      # 
      # @see CompoundInitializer
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class SimpleInitializer < Initializer
        @is_abstract = false
        
        # @return [Expr] 
        attr_reader :expr
        
        def initialize(expr)
          @expr = expect_var[:expr].to_be Expr
          super(expr.start_pos, expr.end_pos)
        end
        
        def print_by(cxt)
          cxt << expr
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(expr, self)
        end
        
        def analyze_stack_by(cxt)
          analyze_scope_of_ivar_by(cxt, :@expr)
        end
      end
    end
  end
end
