module Luca
  class Ast
    class C
      # Cの(型に対する)<tt>sizeof</tt>演算を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class SizeOfTypeExpr < Expr
        @is_abstract = false
        
        # @return [Token]
        attr_reader :sizeof_tk
        
        # @return [Token]
        attr_reader :lparen_tk
        
        # @return [TypeName] 
        attr_reader :type_name
        
        # @return [Token]
        attr_reader :rparen_tk
        
        def initialize(sizeof_tk, lparen_tk, type_name, rparen_tk)
          expect_var[:sizeof_tk].of_instance_to_be Token
          expect_var[:lparen_tk].of_instance_to_be Token
          expect_var[:type_name].of_instance_to_be TypeName
          expect_var[:rparen_tk].of_instance_to_be Token
          super(sizeof_tk.line, rparen_tk.line)
        end
        
        def print_by(cxt)
          cxt << sizeof_tk << lparen_tk << type_name << rparen_tk
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(type_name, self)
        end
        
        def analyze_scope_by(cxt)
          self
        end
      end
    end
  end
end
