module Luca
  class Ast
    class C
      # Cの複合初期化子中の添字指示子を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class SubscriptDesignator < Designator
        @is_abstract = false
        
        # @return [Token]
        attr_reader :lbracket_tk
        
        # @return [Expr] 
        attr_reader :expr
        
        # @return [Token]
        attr_reader :rbracket_tk
        
        def initialize(lbracket_tk, expr, rbracket_tk)
          expect_var[:lbracket_tk].of_instance_to_be Token
          expect_var[:expr].of_instance_to_be Expr
          expect_var[:rbracket_tk].of_instance_to_be Token
          super(lbracket_tk.line, rbracket_tk.line)
        end
        
        def print_by(cxt)
          cxt << lbracket_tk << expr << rbracket_tk
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(expr, self)
        end
      end
    end
  end
end
