module Luca
  class Ast
    class C
      # Cの添字アクセス式を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class SubscriptExpr < Expr
        @is_abstract = false
        
        # @return [Expr] アクセス対象の配列/ポインタ
        attr_reader :array_expr
        
        # @return [Token]
        attr_reader :lbracket_tk
        
        # @return [Expr] 添字式
        attr_reader :index_expr
        
        # @return [Token]
        attr_reader :rbracket_tk
        
        alias_method :array, :array_expr
        alias_method :pointer_expr, :array_expr
        alias_method :pointer, :pointer_expr
        
        alias_method :index, :index_expr
        
        def initialize(array_expr, lbracket_tk, index_expr, rbracket_tk)
          expect_var[:array_expr].of_instance_to_be Expr
          expect_var[:lbracket_tk].of_instance_to_be Token
          expect_var[:index_expr].of_instance_to_be Expr
          expect_var[:rbracket_tk].of_instance_to_be Token
          super(array_expr.start_pos, rbracket_tk.line)
        end
        
        def print_by(cxt)
          cxt << array_expr << lbracket_tk << index_expr << rbracket_tk
        end
        
        def analyze_scope_by(cxt)
          analyze_scope_of_ivar_by(cxt, :@array_expr, :@index_expr)
        end
      end
    end
  end
end
