module Luca
  class Ast
    class C
      # Cの型名(<tt>sizeof</tt>演算子, キャストで使用)を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class TypeName < C
        @is_abstract = false
        
        # @return [[TypeSpecifier, TypeQualifier]] 
        attr_reader :spec_qual_list
        
        # @return [Declarator, nil] 
        attr_reader :declarator
        
        def initialize(spec_qual_list, declarator = nil)
          @spec_qual_list = expect_var[:spec_qual_list].to_be ArrayOf(Or(TypeSpecifier, TypeQualifier)) > 0
          @declarator = expect_var[:declarator].to Maybe(Declarator)
          
          end_pos = declarator ? declarator.end_pos : spec_qual_list.last.end_pos
          super(spec_qual_list.first.start_pos, end_pos)
        end
        
        def print_by(cxt)
          cxt.print_ast_list(spec_qual_list, ' ')
          
          return unless declarator
          cxt << ' '
          cxt.print_ast(declarator)
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_list(spec_qual_list, self)
          cxt.set_parent_of_ast(declarator, self) if declarator
        end
      end
    end
  end
end
