module Luca
  class Ast
    class C
      # ユーザ定義型指定子を表すASTノード
      # 
      # @note このクラスは抽象クラスである
      # @author autopp <autopp.inc@gmail.com>
      #
      class UserTypeSpecifier < TypeSpecifier
        @is_abstract = true
        
        # @return [Token, nil] 型名(無名型ならば<tt>nil</tt>)
        attr_reader :name_tk
        
        def initialize(start_pos, end_pos, name_tk)
          fail "#{self.class} is abstract class" if self.class == UserTypeSpecifier
          expect_var[:name_tk].of_instance_to_be Maybe(Token)
          super(start_pos, end_pos)
        end
        
        def name
          name_tk ? name_tk.value : nil
        end
      end
    end
  end
end
