module Luca
  class Ast
    class C
      # Cの変数を表すAST
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class Var < Expr
        @is_abstract = false
        
        # @return [Token] 変数の名前のトークン
        attr_reader :name_tk
        
        alias_method :pos, :start_pos
        
        def initialize(name_tk)
          expect_var[:name_tk].of_instance_to_be Token
          super(name_tk.line, name_tk.line)
        end
        
        def name
          name_tk.value
        end
        
        def to_c_var
          CVar.new(name_tk)
        end
        
        def to_lua_var(access_path)
          LuaVar.new(name_tk, access_path)
        end
        
        def print_by(cxt)
          cxt << name_tk
        end
        
        def set_parent_by(cxt)
        end
        
        def analyze_scope_by(cxt)
          access_path = cxt.lookup_c_var(name)
          if access_path
            to_lua_var(access_path)
          else
            to_c_var
          end
        end
        
        def gen_code_by(cxt)
          cxt << name_tk
        end
      end
    end
  end
end
