module Luca
  class Ast
    # 全てのLuaのASTノードの親クラス
    # 
    # LuaのASTノードクラスはこのクラスの下に定義されている
    #
    # @author autopp <autopp.inc@gmail.com>
    #
    class Lua < Ast
      def collect_chunk_by(cxt)
        fail NotImplementedError, "#{self.class}#collect_chunk_by is not implemented"
      end
    end
  end
end

require 'luca/ast/lua/block'
require 'luca/ast/lua/return_stmt'
require 'luca/ast/lua/stmt'
require 'luca/ast/lua/decl_stmt'
require 'luca/ast/lua/call_stmt'
require 'luca/ast/lua/assign_stmt'
require 'luca/ast/lua/local_decl_stmt'
require 'luca/ast/lua/empty_stmt'
require 'luca/ast/lua/label_stmt'
require 'luca/ast/lua/goto_stmt'
require 'luca/ast/lua/do_stmt'
require 'luca/ast/lua/break_stmt'
require 'luca/ast/lua/if_stmt'
require 'luca/ast/lua/elseif_part'
require 'luca/ast/lua/while_stmt'
require 'luca/ast/lua/repeat_stmt'
require 'luca/ast/lua/for_stmt'
require 'luca/ast/lua/for_in_stmt'
require 'luca/ast/lua/function_def_stmt'
require 'luca/ast/lua/method_def_stmt'
require 'luca/ast/lua/local_function_def_stmt'
require 'luca/ast/lua/expr'
require 'luca/ast/lua/op_node'
require 'luca/ast/lua/bin_op_node'
require 'luca/ast/lua/logical_and_op_node'
require 'luca/ast/lua/logical_or_op_node'
require 'luca/ast/lua/compare_op_node'
require 'luca/ast/lua/arith_op_node'
require 'luca/ast/lua/concat_op_node'
require 'luca/ast/lua/un_op_node'
require 'luca/ast/lua/not_op_node'
require 'luca/ast/lua/neg_op_node'
require 'luca/ast/lua/len_op_node'
require 'luca/ast/lua/parentheses_expr'
require 'luca/ast/lua/literal'
require 'luca/ast/lua/constant'
require 'luca/ast/lua/boolean_literal'
require 'luca/ast/lua/true'
require 'luca/ast/lua/false'
require 'luca/ast/lua/nil'
require 'luca/ast/lua/number_literal'
require 'luca/ast/lua/int_literal'
require 'luca/ast/lua/float_literal'
require 'luca/ast/lua/string_literal'
require 'luca/ast/lua/vararg'
require 'luca/ast/lua/function_literal'
require 'luca/ast/lua/table_literal'
require 'luca/ast/lua/field'
require 'luca/ast/lua/name_field'
require 'luca/ast/lua/index_field'
require 'luca/ast/lua/key_value_field'
require 'luca/ast/lua/access_expr'
require 'luca/ast/lua/var'
require 'luca/ast/lua/function_call_expr'
require 'luca/ast/lua/method_call_expr'
require 'luca/ast/lua/program'
require 'luca/ast/lua/back_quote_stmt'
require 'luca/ast/lua/back_quote_expr'
require 'luca/ast/lua/c_local_decl_stmt'
require 'luca/ast/lua/protected_decl_stmt'
require 'luca/ast/lua/initialized_protected_decl_stmt'
require 'luca/ast/lua/uninitialized_protected_decl_stmt'
require 'luca/ast/lua/setmetatable_expr'
require 'luca/ast/lua/setmetatable_stmt'
require 'luca/ast/lua/lhs'
require 'luca/ast/lua/var_lhs'
require 'luca/ast/lua/access_lhs'
require 'luca/ast/lua/back_quote_lhs'
require 'luca/ast/lua/local_var'
require 'luca/ast/lua/protected_var'
require 'luca/ast/lua/global_var'
require 'luca/ast/lua/local_var_lhs'
require 'luca/ast/lua/protected_var_lhs'
require 'luca/ast/lua/global_var_lhs'
require 'luca/ast/lua/external_local_var_lhs'
require 'luca/ast/lua/back_quote_call_stmt'
