module Luca
  class Ast
    class Lua
      # Luaの逆クォート式を実行する文
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class BackQuoteStmt < Stmt
        # @return [BackQuoteExpr]
        attr_reader :body
        
        def initialize(body)
          expect_var[:body].of_instance_to_be BackQuoteExpr
          super(body.start_pos, body.end_pos)
        end
        
        def print_by(cxt)
          cxt << body
        end
        
        def desugar_by(cxt)
          desugar_ivar_by(cxt, :@body)
        end
        
        def set_parent_by(cxt)
          cxt.set_parent_of_ast(body, self)
        end
        
        def collect_chunk_by(cxt)
          cxt.collect_from_ast(body)
        end
        
        def analyze_jump_by(cxt); end
        
        def analyze_scope_by(cxt)
          analyze_scope_of_ivar_by(cxt, :@body)
        end
        
        def gen_input_by(cxt)
          cxt.gen_input_of_ast(body)
        end
        
        def analyze_stack_by(cxt)
          cxt.analyze_ast(body, 0)
        end
          
        def gen_code_by(cxt)
          var = cxt.gen_name('size')
          cxt.add_stmt("int #{var} = lua_gettop(#{cxt.state_name})")
          cxt << body
          cxt.call_api('settop', "#{var}")
        end
      end
    end
  end
end
