module Luca
  class Ast
    class Lua
      # 二項演算子を表すASTノード
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class BinOpNode < OpNode
        @is_abstract = true
        
        def initialize(op_pos, operator, left, right)
          fail "#{self.class} is abstract class" if self.class == BinOpNode
          super(left.start_pos, right.end_pos, op_pos, operator, [left, right])
        end
        
        # 左側のオペランドを返す
        #
        #
        # @return [Expr] 
        # 
        def left
          operand_list[0]
        end
        
        # 右側のオペランドを返す
        #
        #
        # @return [Expr] 
        # 
        def right
          operand_list[1]
        end
        
        def print_by(cxt)
          cxt << left << " #{operator.text} " << right
        end
      end
    end
  end
end
