module Luca
  class Ast
    class Lua
      # Luaの真偽値定数を表すASTノード
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class BooleanLiteral < Constant
        @is_abstract = true
        
        def initialize(pos, value)
          fail "#{self.class} is abstract class" if self.class == Boolean
          
          super(pos, pos, value)
        end
        
        # 引数の値に応じてインスタンスを生成する
        #
        # @param [Integer] pos 
        # @param [Boolean] val 
        #
        # @return [Boolean] 
        # 
        def self.create_constant(pos, val)
          case val
          when true
            True.new(pos)
          when false
            False.new(pos)
          else
            fail TypeError, "second argument require Boolean, but got #{val.inspect}"
          end
        end
      end
    end
  end
end
