module Luca
  class Ast
    class Lua
      # Luaの連結演算を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class ConcatOpNode < BinOpNode
        @is_abstract = false
        
        OPERATOR = OpNode::Operator.new('..') do |node, left, right|
          if left.string? && right.string?
            StringLiteral.new(node.op_pos, left.value + right.value)
          else
            node
          end
        end
        
        def initialize(op_pos, left, right)
          super(op_pos, OPERATOR, left, right)
        end
        
        def print_by(cxt)
          cxt << left << '..' << right
        end
        
        def gen_code_by(cxt)
          cxt << left << right
          cxt.call_api('concat', 2)
        end
      end
    end
  end
end
