module Luca
  class Ast
    class Lua
      # Luaの定数リテラルを表すASTノード
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class Constant < Literal
        @is_abstract = true
        
        # @return [object] リテラルが表す値のRuby上の表現
        attr_reader :value
        def initialize(start_pos, end_pos, value)
          fail "#{self}.class is abstract class" if self.class == Constant
          @value = value
          
          super(start_pos, end_pos)
        end
        
        
        def desugar_by(cxt)
          self
        end
        
        def set_parent_by(cxt)
        end
        
        def collect_chunk_by(cxt)
        end
        
        def analyze_scope_by(cxt)
          self
        end
        
        def gen_input_by(cxt)
        end
        
        def analyze_stack_by(cxt)
          1
        end
      end
    end
  end
end
