module Luca
  class Ast
    class Lua
      # Luaの空文を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class EmptyStmt < Stmt
        @is_abstract = false
        
        def initialize(pos)
          super(pos, pos)
        end
        
        def print_by(cxt)
          cxt << ';'
        end
        
        def desugar_by(cxt)
          self
        end
        
        def set_parent_by(cxt)
        end
        
        def collect_chunk_by(cxt)
        end
              
        def analyze_jump_by(cxt)
        end
        
        def analyze_scope_by(cxt)
          self
        end
        
        def analyze_stack_by(cxt)
          0
        end
        
        def gen_input_by(cxt)
        end
        
        def gen_code_by(cxt)
        end
      end
    end
  end
end
