module Luca
  class Ast
    class Lua
      # Luaのfalseリテラルを表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class False < BooleanLiteral
        @is_abstract = false
        
        def initialize(pos)
          super(pos, pos, false)
        end
        
        def print_by(cxt)
          cxt << 'false'
        end
        
        def gen_code_by(cxt)
          cxt.call_api('pushboolean', 0)
        end
      end
    end
  end
end
