module Luca
  class Ast
    class Lua
      @is_abstract = false

      # Luaのグローバル変数の左辺値を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class GlobalVarLhs < VarLhs
        def initialize(pos, name)
          super(pos, name)
        end

        def analyze_stack_of_lvalue_by(cxt)
          0
        end

        def assignment_usage(cxt)
          0
        end

        def stack_usage(cxt)
          0
        end

        def gen_lvalue_code_by(cxt)
          nil
        end

        def gen_assignment_code_by(cxt, state, index)
          cxt.call_api('setglobal', "\"#{name}\"")
        end
      end
    end
  end
end
