module Luca
  class Ast
    class Lua
      # Luaの整数リテラルを表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class IntLiteral < NumberLiteral
        @is_abstract = false
        
        def initialize(pos, value)
          expect_var[:value].of_instance_to_be Integer
          super(pos, value)
        end
        
        def print_by(cxt)
          cxt << value
        end
        
        def gen_code_by(cxt)
          cxt.call_api('pushinteger', value)
        end
      end
    end
  end
end
