module Luca
  class Ast
    class Lua
      # Luaのラベル文を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class LabelStmt < Stmt
        @is_abstract = false
        
        # @return [Symbol] ラベル名
        attr_reader :name
        
        def initialize(start_pos, end_pos, name)
          expect_var[:name].of_instance_to_be Symbol
          super(start_pos, end_pos)
        end
        
        def print_by(cxt)
          cxt << '::' << name << '::'
        end
        
        def desugar_by(cxt)
          self
        end
        
        def set_parent_by(cxt)
        end
        
        def collect_chunk_by(cxt)
          # このラベルを現在のブロックに追加する
          cxt.current_block.add_label(self)
        end
        
        def analyze_jump_by(cxt)
        end
        
        def analyze_scope_by(cxt)
          self
        end
        
        def analyze_stack_by(cxt)
          0
        end
        
        def gen_input_by(cxt)
        end
        
        def gen_code_by(cxt)
          fail NotImplementedError, 'label statement in Lua is not implemented'
        end
      end
    end
  end
end
