module Luca
  class Ast
    class Lua
      # Luaの長さ演算を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class LenOpNode < UnOpNode
        @is_abstract = false
        
        OPERATOR = OpNode::Operator.new('#') do |node, operand|
          if operand.string?
            IntLiteral.new(op_pos, operand.value.legnth)
          else
            node
          end
        end
        
        def initialize(op_pos, operand)
          super(op_pos, OPERATOR, operand)
        end
        
        def gen_code_by(cxt)
          cxt << operand
          cxt.call_api('len', -1)
          cxt.call_api('remove', -2)
        end
      end
    end
  end
end
