module Luca
  class Ast
    class Lua
      # Luaの代入文の左辺を表すASTノード
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class Lhs < Lua
        @is_abstract = true
        
        # 
        #
        # @param [Integer] start_pos 
        # @param [Integer] end_pos 
        # 
        def initialize(start_pos, end_pos)
          fail "#{self.class} is abstract class" if self.class == Lhs
          super(start_pos, end_pos)
        end
        
        def stack_usage
          fail_by_abstract_method
        end
        
        def gen_lvalue_code_by(cxt)
          fail_by_abstract_method
        end
        
        def gen_assignment_code_by(cxt, state, index)
          fail_by_abstract_method
        end
      end
    end
  end
end
