module Luca
  class Ast
    class Lua
      # Luaの論理積演算を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class LogicalAndOpNode < BinOpNode
        @is_abstract = false
        
        OPERATOR = OpNode::Operator.new('and') do |node, left, right|
          if left.falsey?
            left
          else
            right
          end
        end
        
        def initialize(op_pos, left, right)
          super(op_pos, OPERATOR, left, right)
        end
        
        def gen_code_by(cxt)
          # 左辺の生成
          cxt << left
          
          cxt << 'if( ' << cxt.build_api('toboolean', -1) << ' )'
          cxt.nest_block do
            cxt.call_api('pop', 1)
            cxt << right
          end
        end
      end
    end
  end
end
