module Luca
  class Ast
    class Lua
      # Luaの論理和演算を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class LogicalOrOpNode < BinOpNode
        @is_abstract = false
        
        OPERATOR = OpNode::Operator.new('or') do |node, left, right|
          if left.truethy?
            left
          else
            right
          end
        end
        
        def initialize(op_pos, left, right)
          super(op_pos, OPERATOR, left, right)
        end
        
        def gen_code_by(cxt)
          # 左辺の生成
          cxt << left
          
          cxt << 'if( !' << cxt.build_api('toboolean', -1) << ' ){' << cxt.endl
          cxt.next_level do
            cxt.call_api('pop', 1)
            cxt << right
          end
          cxt << '}' << cxt.endl
        end
      end
    end
  end
end
