module Luca
  class Ast
    class Lua
      # Luaのテーブルコンストラクタ({TableLiteral})中の名前付きフィールドを表すASTノード
      # 
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class NameField < Field
        @is_abstract = false
        @is_syntax_sugar = true
        
        # @return [Symbol] フィールドの名前
        attr_reader :name
        alias_method :key, :name
        
        def initialize(start_pos, name, value_expr)
          expect_var[:name].of_instance_to_be Symbol
          super(start_pos, value_expr)
        end
        
        def print_by(cxt)
          cxt << "#{name} = " << value_expr
        end
        
        # ["name"] = value の形式へdesugarする
        #
        # @param [DesugarContext] cxt 
        #
        # @return [KeyValueField] desugar済みのAST
        # 
        def desugar_by(cxt)
          desugar_ivar_by(cxt, :@value_expr)
          expect_var[:@value_expr].to_be Expr
          key_expr = StringLiteral.new(start_pos, "#{name}")
          KeyValueField.new(start_pos, key_expr, value_expr)
        end
      end
    end
  end
end
