module Luca
  class Ast
    class Lua
      # 符号反転演算を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class NegOpNode < UnOpNode
        @is_abstract = false
        
        OPERATOR = OpNode::Operator.new('-') do |node, operand|
          if operand.number?
            NumberLiteral.create_constant(node_pos, - operand.value)
          else
            node
          end
        end
        
        def initialize(op_pos, operand)
          
          super(op_pos, OPERATOR, operand)
        end
        
        def print_by(cxt)
          # 符号反転が連続する場合, Lua上の行コメントにならないようにスペースを入れる
          cxt << '-'
          cxt << ' ' if operand.is_a?(NegOpNode)
          cxt << operand
        end
        
        def gen_code_by(cxt)
          cxt << operand
          cxt.call_api('arith', LUA_OPUNM)
        end
      end
    end
  end
end
