module Luca
  class Ast
    class Lua
      # 論理反転演算を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class NotOpNode < UnOpNode
        @is_abstract = false
        
        OPERATOR = OpNode::Operator.new('not ') do |node, operand|
          if operand.truety?
            False.new(node.op_pos)
          else
            True.new(node.op_pos)
          end
        end
        
        def initialize(op_pos, operand)
          
          super(op_pos, OPERATOR, operand)
        end
        
        def gen_code_by(cxt)
          cxt << operand
          
          var = cxt.gen_var('tmp')
          cxt.add_stmt("int #{var} = " + cxt.build_api('toboolean', -1))
          cxt.call_api('pop', 1)
          cxt.call_api('pushboolean', "!#{var}")
        end
      end
    end
  end
end
