module Luca
  class Ast
    class Lua
      # Luaの数値リテラルを表すASTノード
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class NumberLiteral < Constant
        @is_abstract = true
        
        def initialize(pos, value)
          fail "#{self.class} is abstract class" if self.class == NumberLiteral
          super(pos, pos, value)
        end
        
        def self.create_constant(pos, value)
          case value
          when Integer
            IntLiteral.new(pos, value)
          when Float
            FloatLiteral.new(pos, value)
          else
            fail TypeError, "second argument require Integer or Float, but got #{value.inspect}"
          end
        end
      end
    end
  end
end
