module Luca
  class Ast
    class Lua
      # Luaの<tt>protected</tt>変数を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class ProtectedVar < Var
        # 
        #
        # @param [Symbol] name 変数名
        # @param [Integer] pos 行番号
        # 
        def initialize(pos, name)
          super(pos, name)
        end
        
        def gen_input_by(cxt); end
        
        def analyze_stack_by(cxt)
          1
        end
        
        def gen_code_by(cxt)
          cxt.call_api('getfield', 'LUA_REGISTRYINDEX', "\"#{name}\"")
        end
      end
    end
  end
end
