module Luca
  class Ast
    class Lua
      # Luaの文字列リテラルを表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class StringLiteral < Constant
        @is_abstract = false
        
        def initialize(pos, value)
          super(pos, pos, value)
        end
        
        def print_by(cxt)
          cxt << value.inspect
        end
        
        def desugar_by(cxt)
          self
        end
        
        def gen_code_by(cxt)
          cxt.call_api('pushlstring', value.inspect, value.size)
        end
      end
    end
  end
end
