module Luca
  class Ast
    class Lua
      # 単項演算を表すASTノード
      # 
      # @note このクラスは抽象クラスである
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class UnOpNode < OpNode
        @is_abstract = true
        
        def initialize(op_pos, operator, operand)
          fail "#{self.class} is abstract class" if self.class == UnOpNode
          
          super(op_pos, operand.end_pos, op_pos, operator, [operand])
        end
        
        # オペランドを返す
        #
        #
        # @return [Expr]
        # 
        def operand
          operand_list.first
        end
        
        def print_by(cxt)
          cxt << operator.text << operand
        end
      end
    end
  end
end
