module Luca
  class Ast
    class Lua
      # Luaの<tt>protected</tt>宣言文(初期化なし)を表すASTノード
      #
      # @author autopp <autopp.inc@gmail.com>
      #
      class UninitializedProtectedDeclStmt < ProtectedDeclStmt
        def initialize(kw_pos, end_pos, var_list)
          super(kw_pos, end_pos, var_list)
        end
        
        def desugar_by(cxt)
          self
        end
        
        def set_parent_by(cxt); end
        
        def collect_chunk_by(cxt); end
        
        def analyze_jump_by(cxt); end
        
        def analyze_scope_by(cxt)
          self
        end
        
        def analyze_stack_by(cxt)
          0
        end
        
        def gen_input_by(cxt); end
        
        def gen_code_by(cxt); end
      end
    end
  end
end
