module Luca
  # デバッグ用のユーティリティモジュール
  #
  # @author autopp <autopp.inc@gmail.com>
  #
  module DebugUtils
    class << self
      attr_accessor :mode
      
      def print_header
        if caller[3] =~ /^(.+?):(\d+)(?::in `.*')?/
          file = File.basename(Regexp.last_match[1])
          line = Regexp.last_match[2]
        end
        
        $stderr.print format(DebugUtils::HEADER_FORMAT, file, line)
      end
    end
    
    HEADER_FORMAT = '[%s:%03d] '
    
    module_function
    
    def dputs(*args)
      if DebugUtils.mode
        args.each do |a|
          DebugUtils.print_header
          $stderr.puts(a)
        end
      end
      
      args.size == 1 ? args.first : args
    end
    
    def dp(*args)
      if DebugUtils.mode
        args.each do |a|
          DebugUtils.print_header
          $stderr.puts(a.inspect)
        end
      end
      
      args.size == 1 ? args.first : args
    end
  end
end
