module Luca
  class Parser
    class TypedefTable
      include Varspec
      include Varspec::BuiltinMatcher
      
      attr_reader :table
      
      def initialize
        @table = {}
      end
      
      def <<(sym)
        expect_var[:sym].to_be Symbol
        
        if table.member?(sym)
          table[sym] += 1
        else
          table[sym] = 1
        end
        
        self
      end
      
      alias_method :add, :<<
      
      def [](sym)
        table[sym]
      end
      
      alias_method :get, :[]
      
      def member?(sym)
        table.member?(sym)
      end
      
      def delete(sym)
        expect_var[:sym].to_be Symbol
        v = table[sym]
        expect_var[:v].to_be Integer
        
        if v > 1
          table[sym] -= 1
        elsif v == 1
          table.delete[sym]
        else
          fail "count of #{sym} is negative (THIS IS BUG)"
        end
      end
    end
  end
end
