module Luca
  class SyntaxError < RuntimeError
    include Varspec::BuiltinMatcher
    
    def initialize(loc, token_name, token)
      expect_var[:loc].to_be LocationMap::Location
      expect_var[:token_name].to_be String
      expect_var[:token].to_be Or(Token, false)
      
      msg = "#{loc.filename}:#{loc.line}: unexpected #{token_name}"
      if token_name == 'error'
        msg = "#{loc.filename}:#{loc.line}: unexpected #{token.value}"
      elsif token_name == 'C_NAME' || token_name == 'Lua_NAME'
        msg << " `#{token.value}'"
      end
      
      super(msg)
    end
  end
end
