#!/usr/bin/ruby

module Luca
  # Lexerが返すペアの第2要素に用いられるクラス. 
  # トークンの行番号と値を保持する. 
  #
  # @author Akira Tanimura <tanimura@ipl.cs.uec.ac.jp>
  #
  class Token
    # @return [Integer] トークンが現れた行番号を返す
    attr_reader :line
    
    # @return [Object] トークンの持つ値
    attr_reader :value
    
    # @return [Integer] このトークンの直前の改行の数
    attr_reader :newline_count
    
    def initialize(line, value, newline_count)
      expect_var[:line].of_instance_to_be Integer
      @value = value
      expect_var[:newline_count].of_instance_to_be Integer
    end
    
    def analyze_scope_by(cxt)
      self
    end
  end
end
